//: C01:Basexcpt.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Hierarchie výjimek.
#include <iostream>
using namespace std;

class X {
public:
  class Potize {};
  class Male : public Potize {};
  class Velke : public Potize {};
  void f() { throw Velke(); }
};

int main() {
  X x;
  try {
    x.f();
  } catch(X::Potize&) {
    cout << "zachyceny Potize" << endl;
  // Zakryté předchozím správcem:
  } catch(X::Male&) {
    cout << "zachyceny Male Potize" << endl;
  } catch(X::Velke&) {
    cout << "zachyceny Velke Potize" << endl;
  }
} ///:~
